Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.singularsys.jep.functions
Class If

    java.lang.Object
      com.singularsys.jep.functions.PostfixMathCommand
          com.singularsys.jep.functions.If

All Implemented Interfaces:
  CallbackEvaluationI, PostfixMathCommandI, java.io.Serializable

    public class If

extends PostfixMathCommand
implements CallbackEvaluationI

The if(condExpr, posExpr, negExpr) function. The value of trueExpr will be returned if condExpr is >0 or Boolean.TRUE and value of negExpr will be returned if condExpr is <= 0 or Boolean.TRUE. If condExpr is NaN then NaN is returned.

This function performs lazy evaluation so that only posExpr or negExpr will be evaluated. For Complex numbers only the real part is used.

An alternate form if(condExpr, posExpr, negExpr, zeroExpr) is also available. Note most computations are carried out over floating point doubles so testing for zero can be dangerous.

This function implements the SpecialEvaluationI interface so that it handles setting the value of a variable.

Since:
  Feb 05 Handles Number arguments, so works with Integers rather than just Doubles
Version:
  2.3.0 beta 1 now supports a Boolean first argument.
Author:
  Rich Morris Created on 18-Nov-2003
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.singularsys.jep.functions.CallbackEvaluationI
`CallbackEvaluationI.Runnable`

Field Summary

Fields inherited from class com.singularsys.jep.functions.PostfixMathCommand
`curNumberOfParameters, name, NaN, numberOfParameters`

Constructor Summary
`If()`
`If(java.lang.Object falseValue)`

Method Summary
`boolean` | `checkNumberOfParameters(int n)` Checks the number of parameters of the call.
`java.lang.Object` | `evaluate(Node node, Evaluator pv)` Performs some special evaluation on the node.
`void` | `run(java.util.Stack<java.lang.Object> aStack)` Run the function on the stack.

Methods inherited from class com.singularsys.jep.functions.PostfixMathCommand
`asArray, asBool, asDouble, asInt, asLong, asStrictInt, asString, checkStack, getName, getNumberOfParameters, setCurNumberOfParameters, setName, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### If

    public If()

### If

    public If(java.lang.Object falseValue)

Parameters:
  `falseValue` -

Method Detail

### checkNumberOfParameters

    public boolean checkNumberOfParameters(int n)

  Checks the number of parameters of the call.

  Specified by:
    `checkNumberOfParameters` in interface `PostfixMathCommandI`
  Overrides:
    `checkNumberOfParameters` in class `PostfixMathCommand`
  Parameters:
    `n` - number of parameters function will be called with.
  Returns:
    false if an illegal number of parameters is supplied, true otherwise.

### evaluate

    public java.lang.Object evaluate(Node node,
                                     Evaluator pv)
                              throws EvaluationException

  Description copied from interface: `CallbackEvaluationI`
  Performs some special evaluation on the node. This method has the responsibility for evaluating the children of the node and it should generally call

       pv.eval(node.jjtGetChild(i))

  for each child. The SymbolTable is not passed as an argument. This is because it is better practice to get and set variable values by using node.getVar().setValue() rather that through the SymbolTable with requires a hashtable lookup.

  Specified by:
    `evaluate` in interface `CallbackEvaluationI`
  Parameters:
    `node` - The current node
    `pv` - The visitor, can be used evaluate the children
  Returns:
    the value after evaluation
  Throws:
    `EvaluationException`
  See Also:
    `Evaluator`

### run

    public void run(java.util.Stack<java.lang.Object> aStack)
             throws EvaluationException

  Description copied from interface: `PostfixMathCommandI`
  Run the function on the stack. Pops the arguments from the stack, and pushes the result on the top of the stack.

  Specified by:
    `run` in interface `PostfixMathCommandI`
  Throws:
    `EvaluationException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008 Singular Systems http://www.singularsys.com/jep